# coding: utf-8

"""
    SCORM Cloud Rest API

    REST API used for SCORM Cloud integrations.  # noqa: E501

    OpenAPI spec version: 2.0 beta
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from rustici_software_cloud_v2.api_client import ApiClient


class AuthenticationApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_app_token(self, scope, **kwargs):  # noqa: E501
        """Authenticates for a oauth token  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_app_token(scope, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str scope: (required)
        :param int expiration:
        :return: ApplicationToken
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_app_token_with_http_info(scope, **kwargs)  # noqa: E501
        else:
            (data) = self.get_app_token_with_http_info(scope, **kwargs)  # noqa: E501
            return data

    def get_app_token_with_http_info(self, scope, **kwargs):  # noqa: E501
        """Authenticates for a oauth token  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_app_token_with_http_info(scope, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str scope: (required)
        :param int expiration:
        :return: ApplicationToken
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['scope', 'expiration']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_app_token" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'scope' is set
        if ('scope' not in params or
                params['scope'] is None):
            raise ValueError("Missing the required parameter `scope` when calling `get_app_token`")  # noqa: E501

        if 'expiration' in params and params['expiration'] > 43200:  # noqa: E501
            raise ValueError("Invalid value for parameter `expiration` when calling `get_app_token`, must be a value less than or equal to `43200`")  # noqa: E501
        if 'expiration' in params and params['expiration'] < 60:  # noqa: E501
            raise ValueError("Invalid value for parameter `expiration` when calling `get_app_token`, must be a value greater than or equal to `60`")  # noqa: E501
        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}
        if 'scope' in params:
            form_params.append(('scope', params['scope']))  # noqa: E501
        if 'expiration' in params:
            form_params.append(('expiration', params['expiration']))  # noqa: E501

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/x-www-form-urlencoded'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APP_NORMAL']  # noqa: E501

        return self.api_client.call_api(
            '/oauth/authenticate/application/token', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApplicationToken',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
