# coding: utf-8

"""
    SCORM Cloud Rest API

    REST API used for SCORM Cloud integrations.  # noqa: E501

    OpenAPI spec version: 2.0 beta
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class PostBackSchema(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'url': 'str',
        'auth_type': 'str',
        'user_name': 'str',
        'password': 'str',
        'results_format': 'str'
    }

    attribute_map = {
        'url': 'url',
        'auth_type': 'authType',
        'user_name': 'userName',
        'password': 'password',
        'results_format': 'resultsFormat'
    }

    def __init__(self, url=None, auth_type='UNDEFINED', user_name=None, password=None, results_format='COURSE'):  # noqa: E501
        """PostBackSchema - a model defined in Swagger"""  # noqa: E501

        self._url = None
        self._auth_type = None
        self._user_name = None
        self._password = None
        self._results_format = None
        self.discriminator = None

        if url is not None:
            self.url = url
        if auth_type is not None:
            self.auth_type = auth_type
        if user_name is not None:
            self.user_name = user_name
        if password is not None:
            self.password = password
        if results_format is not None:
            self.results_format = results_format

    @property
    def url(self):
        """Gets the url of this PostBackSchema.  # noqa: E501


        :return: The url of this PostBackSchema.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this PostBackSchema.


        :param url: The url of this PostBackSchema.  # noqa: E501
        :type: str
        """

        self._url = url

    @property
    def auth_type(self):
        """Gets the auth_type of this PostBackSchema.  # noqa: E501

        Optional parameter to specify how to authorize against the given postbackurl, can be 'form' or 'httpbasic'. If form authentication, the username and password for authentication are submitted as form fields 'username' and 'password', and the registration data as the form field 'data'. If httpbasic authentication is used, the username and password are placed in the standard Authorization HTTP header, and the registration data is the body of the message (sent as text/xml content type). This field is set to 'form' by default.  # noqa: E501

        :return: The auth_type of this PostBackSchema.  # noqa: E501
        :rtype: str
        """
        return self._auth_type

    @auth_type.setter
    def auth_type(self, auth_type):
        """Sets the auth_type of this PostBackSchema.

        Optional parameter to specify how to authorize against the given postbackurl, can be 'form' or 'httpbasic'. If form authentication, the username and password for authentication are submitted as form fields 'username' and 'password', and the registration data as the form field 'data'. If httpbasic authentication is used, the username and password are placed in the standard Authorization HTTP header, and the registration data is the body of the message (sent as text/xml content type). This field is set to 'form' by default.  # noqa: E501

        :param auth_type: The auth_type of this PostBackSchema.  # noqa: E501
        :type: str
        """
        allowed_values = ["UNDEFINED", "FORM", "HTTPBASIC"]  # noqa: E501
        if auth_type not in allowed_values:
            raise ValueError(
                "Invalid value for `auth_type` ({0}), must be one of {1}"  # noqa: E501
                .format(auth_type, allowed_values)
            )

        self._auth_type = auth_type

    @property
    def user_name(self):
        """Gets the user_name of this PostBackSchema.  # noqa: E501

        The user name to be used in authorizing the postback of data to the URL specified by postback url.  # noqa: E501

        :return: The user_name of this PostBackSchema.  # noqa: E501
        :rtype: str
        """
        return self._user_name

    @user_name.setter
    def user_name(self, user_name):
        """Sets the user_name of this PostBackSchema.

        The user name to be used in authorizing the postback of data to the URL specified by postback url.  # noqa: E501

        :param user_name: The user_name of this PostBackSchema.  # noqa: E501
        :type: str
        """

        self._user_name = user_name

    @property
    def password(self):
        """Gets the password of this PostBackSchema.  # noqa: E501

        The password to be used in authorizing the postback of data to the URL specified by postback url.  # noqa: E501

        :return: The password of this PostBackSchema.  # noqa: E501
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """Sets the password of this PostBackSchema.

        The password to be used in authorizing the postback of data to the URL specified by postback url.  # noqa: E501

        :param password: The password of this PostBackSchema.  # noqa: E501
        :type: str
        """

        self._password = password

    @property
    def results_format(self):
        """Gets the results_format of this PostBackSchema.  # noqa: E501

        This parameter allows you to specify a level of detail in the information that is posted back while the course is being taken. It may be one of three values: 'course' (course summary), 'activity' (activity summary, or 'full' (full detail), and is set to 'course' by default. The information will be posted as xml, and the format of that xml is specified below under the method 'getRegistrationResult'  # noqa: E501

        :return: The results_format of this PostBackSchema.  # noqa: E501
        :rtype: str
        """
        return self._results_format

    @results_format.setter
    def results_format(self, results_format):
        """Sets the results_format of this PostBackSchema.

        This parameter allows you to specify a level of detail in the information that is posted back while the course is being taken. It may be one of three values: 'course' (course summary), 'activity' (activity summary, or 'full' (full detail), and is set to 'course' by default. The information will be posted as xml, and the format of that xml is specified below under the method 'getRegistrationResult'  # noqa: E501

        :param results_format: The results_format of this PostBackSchema.  # noqa: E501
        :type: str
        """
        allowed_values = ["COURSE", "ACTIVITY", "FULL"]  # noqa: E501
        if results_format not in allowed_values:
            raise ValueError(
                "Invalid value for `results_format` ({0}), must be one of {1}"  # noqa: E501
                .format(results_format, allowed_values)
            )

        self._results_format = results_format

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PostBackSchema, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PostBackSchema):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
